//
//  AnnotationViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/25.
//

import Foundation

class AnnotationViewController: MAMapBaseViewController {
    
    var annotations:Array<Any> = [];
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        map.createMap()
        self.addWebView()
        
        initAnnotation()
    }
    
    func initAnnotation(){
        
        annotations = Array.init()
        
        let coordinates: [CLLocationCoordinate2D] = [
            CLLocationCoordinate2D(latitude: 39.992520, longitude: 116.336170),
            CLLocationCoordinate2D(latitude: 39.978234, longitude: 116.352343),
            CLLocationCoordinate2D(latitude: 39.998293, longitude: 116.348904),
            CLLocationCoordinate2D(latitude: 40.004087, longitude: 116.353915),
            CLLocationCoordinate2D(latitude: 40.001442, longitude: 116.353915),
            CLLocationCoordinate2D(latitude: 39.989105, longitude: 116.360200),
            CLLocationCoordinate2D(latitude: 39.989098, longitude: 116.360201),
            CLLocationCoordinate2D(latitude: 39.998439, longitude: 116.324219),
            CLLocationCoordinate2D(latitude: 39.979590, longitude: 116.352792)]
        
        for (idx, coor) in coordinates.enumerated() {
            let anno = MAPointAnnotation()
            anno.coordinate = coor
            anno.title = String(idx)
            
            annotations.append(anno)
        }
    }
    
    func mapReady(_ map: MAMap) {
        self.map.addAnnotations(annotations)
        self.map .showAnnotations(annotations, animated: true)
    }
    
    func map(_ map: MAMap, viewFor annotation: MAAnnotation) -> MAAnnotationView! {
        if annotation.isKind(of: MAPointAnnotation.self) {
            let annotationView = MAPinAnnotationView.init(annotation: annotation)
            annotationView?.canShowCallout = true
            annotationView?.isDraggable = true
            annotationView?.rightCalloutAccessoryView = UIButton.init(type: UIButton.ButtonType.detailDisclosure)
            return annotationView!
        }
        
        return nil
    }

}
