//
//  MapTypeViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/25.
//

import Foundation

class MapTypeViewController: MAMapBaseViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        map.createMap()
        
        self.addWebView()
        
        initToolBar()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        self.navigationController?.setToolbarHidden(false, animated: true)
    }
    
    func initToolBar() {
        let flexibleItem = UIBarButtonItem(barButtonSystemItem: UIBarButtonItem.SystemItem.flexibleSpace, target: nil, action: nil)
        
        let segmentControl = UISegmentedControl(items: ["标准", "卫星","黑夜"])
        segmentControl.selectedSegmentIndex = map.mapType.rawValue-1
        segmentControl.addTarget(self, action:#selector(self.mapTypeAction(sender:)), for: UIControl.Event.valueChanged)
        let segmentItem = UIBarButtonItem(customView: segmentControl)
        self.toolbarItems = [flexibleItem, segmentItem, flexibleItem]
    }
    
    //MARK: - Actions
    @objc func mapTypeAction(sender: UISegmentedControl)
    {
        map.mapType = MAMapType(rawValue: sender.selectedSegmentIndex + 1)!
    }
}
