//
//  ChangeZoomViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/25.
//

import Foundation

class ChangeZoomViewController: MAMapBaseViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        self.addWebView()
        
        let zoomPannelView = self.makeZoomPannelView()
        zoomPannelView.center = CGPoint.init(x: self.view.bounds.size.width -  zoomPannelView.bounds.width/2 - 10, y: self.view.bounds.size.height -  zoomPannelView.bounds.width/2 - 30)
        
        zoomPannelView.autoresizingMask = [UIView.AutoresizingMask.flexibleTopMargin , UIView.AutoresizingMask.flexibleLeftMargin]
        self.view.addSubview(zoomPannelView)
    }
    
    func makeZoomPannelView() -> UIView {
        let ret = UIView.init(frame: CGRect.init(x: 0, y: 0, width: 53, height: 98))
        
        let incBtn = UIButton.init(frame: CGRect.init(x: 0, y: 0, width: 53, height: 49))
        incBtn.setImage(UIImage.init(named: "increase"), for: UIControl.State.normal)
        incBtn.sizeToFit()
        incBtn.addTarget(self, action: #selector(self.zoomPlusAction), for: UIControl.Event.touchUpInside)
        
        let decBtn = UIButton.init(frame: CGRect.init(x: 0, y: 49, width: 53, height: 49))
        decBtn.setImage(UIImage.init(named: "decrease"), for: UIControl.State.normal)
        decBtn.sizeToFit()
        decBtn.addTarget(self, action: #selector(self.zoomMinusAction), for: UIControl.Event.touchUpInside)
        
        ret.addSubview(incBtn)
        ret.addSubview(decBtn)

        return ret
    }
    
    
    //MARK:- event handling
    //放大
    @objc func zoomPlusAction() {
        let oldZoom = self.map.zoomLevel
        self.map.setZoomLevel(oldZoom+1, animated: true)
    }
    
    //缩小
    @objc func zoomMinusAction() {
        let oldZoom = self.map.zoomLevel
        self.map.setZoomLevel(oldZoom-1, animated: true)
    }
}
