//
//  LongGestureViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class LongGestureViewController: MAMapBaseViewController,UIGestureRecognizerDelegate {
    
    var longPressGestureRecognizer:UILongPressGestureRecognizer! = nil;
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        self.addWebView()
        
        self.initLongGesture();
    }
    
    func initLongGesture(){
        longPressGestureRecognizer = UILongPressGestureRecognizer.init(target: self, action: #selector(longPressGesture(_ :)))
        longPressGestureRecognizer.delegate = self
        self.view.addGestureRecognizer(longPressGestureRecognizer)
    }
    
    //MARK: - MAMapViewDelegate
    func map(_ map: MAMap, didLongPressedAt coordinate: CLLocationCoordinate2D) {
        print("LongGesture coordinate: lat = %.6lf,lon = %.6lf",coordinate.latitude,coordinate.longitude);
        
        let p:MAPointAnnotation = MAPointAnnotation.init()
        p.coordinate = coordinate;
        self.map.addAnnotation(p)
    }
    
    //MARK: - longPressGesture
    @objc func longPressGesture(_ longPressGesture:UILongPressGestureRecognizer){
        self.map.longPressGesture(longPressGesture)
    }
    
    
    func gestureRecognizer(_ gestureRecognizer: UIGestureRecognizer, shouldRecognizeSimultaneouslyWith otherGestureRecognizer: UIGestureRecognizer) -> Bool {
        if gestureRecognizer == longPressGestureRecognizer {
            return true
        }
        return false
    }

}
