//
//  MapBoundaryViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class MapBoundaryViewController: MAMapBaseViewController {
    
    var overlays: Array<MAOverlay>!
    var limitRegion: MACoordinateRegion!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        self.addWebView()
        
        self.view.backgroundColor = UIColor.gray
        
        self.limitRegion = MACoordinateRegion.init(center: CLLocationCoordinate2D.init(latitude: 40, longitude: 116), span: MACoordinateSpan.init(latitudeDelta: 2, longitudeDelta: 2))
        initBorderLine()
    }
    
    func initBorderLine() {
        overlays = Array()
        
        // polyline
        var lineCoordinates: [CLLocationCoordinate2D] = [
            CLLocationCoordinate2D(latitude: self.limitRegion.center.latitude + self.limitRegion.span.latitudeDelta/2, longitude: self.limitRegion.center.longitude - self.limitRegion.span.longitudeDelta/2),
            
            CLLocationCoordinate2D(latitude: self.limitRegion.center.latitude + self.limitRegion.span.latitudeDelta/2, longitude: self.limitRegion.center.longitude + self.limitRegion.span.longitudeDelta/2),
            
            CLLocationCoordinate2D(latitude: self.limitRegion.center.latitude - self.limitRegion.span.latitudeDelta/2, longitude: limitRegion.center.longitude + self.limitRegion.span.longitudeDelta/2),
            
            CLLocationCoordinate2D(latitude: self.limitRegion.center.latitude - self.limitRegion.span.latitudeDelta/2, longitude: self.limitRegion.center.longitude - self.limitRegion.span.longitudeDelta/2),
            
            CLLocationCoordinate2D(latitude: self.limitRegion.center.latitude + self.limitRegion.span.latitudeDelta/2, longitude: self.limitRegion.center.longitude - self.limitRegion.span.longitudeDelta/2)]
        
        let polyline: MAPolyline = MAPolyline(coordinates: &lineCoordinates, count: UInt(lineCoordinates.count))
        overlays.append(polyline)
    }
    
    //MARK: - MAMapViewDelegate
    func mapReady(_ map: MAMap) {
        self.map.limitRegion = self.limitRegion
        
        map.addOverlays(overlays)
    }
    
    func map(_ map: MAMap!, rendererFor overlay: MAOverlay!) -> MAOverlayRenderer! {
        if overlay.isKind(of: MAPolyline.self) {
            let renderer: MAPolylineRenderer = MAPolylineRenderer(overlay: overlay)
            renderer.lineWidth = 4.0
            renderer.strokeColor = UIColor.red
            
            return renderer
        }
        
        return nil
    }
}
