//
//  CoordinateConvertViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class CoordinateConvertViewController: MAMapBaseViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        addWebView()
        
        let label = UILabel.init(frame: CGRect.init(x: 0, y: 0, width: self.view.bounds.size.width, height: 40))
        label.textAlignment = NSTextAlignment.center
        label.backgroundColor = UIColor.black.withAlphaComponent(0.5)
        label.textColor = UIColor.white
        label.text = "点击地图显示屏幕坐标"
        label.autoresizingMask = [UIView.AutoresizingMask.flexibleWidth, UIView.AutoresizingMask.flexibleBottomMargin]
        self.view.addSubview(label)
    }
    
    func map(_ map: MAMap, didSingleTappedAt coordinate: CLLocationCoordinate2D) {
        map.convert(coordinate) { (point) in
            self.view.makeToast(String.init(format: "screenPoint =  {%f, %f}", point.x, point.y), duration: 1.5)
        }
    }
}
