//
//  InsideTestViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class InsideTestViewController: MAMapBaseViewController {
    
    var pin: MAPointAnnotation!
    var polygon:MAPolygon!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        addWebView()
    }
    
    func initAnnotations() {
        pin = MAPointAnnotation.init()
        pin.coordinate = CLLocationCoordinate2DMake(39.992520, 116.336170)
        pin.title = "拖动我哦"
        
        map.addAnnotations([pin!])
        map.selectAnnotation(pin, animated: true)
    }
    
    func initPolygon() {
        var coords = [CLLocationCoordinate2DMake(39.881892, 116.293413),
                      CLLocationCoordinate2DMake(39.887600, 116.391842),
                      CLLocationCoordinate2DMake(39.833187, 116.417932),
                      CLLocationCoordinate2DMake(39.804653, 116.338255)]
        
        polygon = MAPolygon.init(coordinates: &coords, count: UInt(coords.count))
        map.add(polygon)
    }
    
    //MARK: - mapview delegate
    func mapReady(_ map: MAMap) {
        initAnnotations()
        initPolygon()
    }
    
    func map(_ map: MAMap!, viewFor annotation: MAAnnotation!) -> MAAnnotationView! {
        
        if annotation.isKind(of: MAPointAnnotation.self) {
            if annotation.isKind(of: MAPointAnnotation.self) {
                let annotationView = MAPinAnnotationView.init(annotation: annotation)
                annotationView?.canShowCallout = true
                annotationView?.isDraggable = true
                
                return annotationView!
            }
        }
        
        return nil
    }
    
    func map(_ mapView:MAMap, annotationView:MAAnnotationView, didChange newState:MAAnnotationViewDragState, fromOldState:MAAnnotationViewDragState) {
        if(newState == MAAnnotationViewDragState.ending) {
            let loc = self.pin.coordinate
            let p = MAMapPointForCoordinate(loc)
            
            if(MAPolygonContainsPoint(p, self.polygon.points, 4)) {
                self.view.makeToast("inside", duration: 1.5)
            } else {
                self.view.makeToast("not inside", duration:1.5);
            }
        }
    }
    
    func map(_ mapView: MAMap!, rendererFor overlay: MAOverlay!) -> MAOverlayRenderer! {
        
        if (overlay.isKind(of: MAPolygon.self))
        {
            let renderer = MAPolygonRenderer.init(polygon: overlay as! MAPolygon?)
            renderer?.strokeColor = UIColor.blue
            renderer?.fillColor = UIColor.red
            renderer?.lineWidth = 2.0
            renderer?.lineDashType = kMALineDashTypeNone
            
            return renderer;
        }
        
        return nil;
    }
}
