//
//  PointToPointDistanceViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class PointToPointDistanceViewController: MAMapBaseViewController {
    
    var pin1: MAPointAnnotation!
    var pin2: MAPointAnnotation!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        addWebView()
    }
    
    func initAnnotations() {
        pin1 = MAPointAnnotation.init()
        pin2 = MAPointAnnotation.init()
        
        pin1.coordinate = CLLocationCoordinate2DMake(39.992520, 116.336170)
        pin2.coordinate = CLLocationCoordinate2DMake(39.892520, 116.436170)
        pin2.title = "拖动我哦"
        
        map.addAnnotations([pin1 as Any, pin2 as Any])
        map.selectAnnotation(pin2, animated: true)
    }
    
    //MARK: - mapview delegate
    func mapReady(_ map: MAMap) {
        initAnnotations()
    }
    
    func map(_ map: MAMap!, viewFor annotation: MAAnnotation!) -> MAAnnotationView! {
        
        if annotation.isKind(of: MAPointAnnotation.self) {
            let annotationView = MAPinAnnotationView.init(annotation: annotation)
            annotationView?.canShowCallout = true
            annotationView?.isDraggable = true
            
            return annotationView!
        }
        
        return nil
    }
    
    func map(_ map:MAMap, annotationView:MAAnnotationView, didChange newState:MAAnnotationViewDragState, fromOldState:MAAnnotationViewDragState) {
        if(newState == MAAnnotationViewDragState.ending) {
            let loc1 = self.pin1.coordinate
            let loc2 = self.pin2.coordinate
            
            let p1 = MAMapPointForCoordinate(loc1)
            let p2 = MAMapPointForCoordinate(loc2)
            
            let distance =  MAMetersBetweenMapPoints(p1, p2)
            
            self.view.makeToast(String.init(format: "distance between two pins = %.2f", distance), duration: 1.5)
        }

    }
}
