//
//  ColoredLinesOverlayViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class ColoredLinesOverlayViewController: MAMapBaseViewController {
    
    var lines: Array<MAOverlay>!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //加载地图
        map.createMap()
        //在视图上添加webView
        addWebView()
        
        initLines();
        
    }
    
    func initLines() {
        lines = Array()
        
        /* Colored Polyline. */
        var coloredPolylineCoords:[CLLocationCoordinate2D] = [CLLocationCoordinate2DMake(39.938698, 116.275177),
                                                              CLLocationCoordinate2DMake(39.966069, 116.289253),
                                                              CLLocationCoordinate2DMake(39.944226, 116.306076),
                                                              CLLocationCoordinate2DMake(39.966069, 116.322899),
                                                              CLLocationCoordinate2DMake(39.938698, 116.336975)];
        

        let coloredPolyline = MAMultiPolyline.init(coordinates: &coloredPolylineCoords, count: UInt(coloredPolylineCoords.count), drawStyleIndexes: [1, 3])
        
        lines.append(coloredPolyline!)
        
        /* Gradient Polyline. */
        var gradientPolylineCoords:[CLLocationCoordinate2D] = [CLLocationCoordinate2DMake(39.938698, 116.351051),
                                                              CLLocationCoordinate2DMake(39.966069, 116.366844),
                                                              CLLocationCoordinate2DMake(39.938698, 116.381264),
                                                              CLLocationCoordinate2DMake(39.938698, 116.395683),
                                                              CLLocationCoordinate2DMake(39.950067, 116.395683),
                                                              CLLocationCoordinate2DMake(39.950437, 116.423449),
                                                              CLLocationCoordinate2DMake(39.966069, 116.423449),
                                                              CLLocationCoordinate2DMake(39.966069, 116.395683)];
        
        
        let gradientPolyline = MAMultiPolyline.init(coordinates: &gradientPolylineCoords, count: UInt(gradientPolylineCoords.count), drawStyleIndexes: [0,2,3,7])
        
        lines.append(gradientPolyline!)
    }
    
    //MARK: - MAMapViewDelegate
    func mapReady(_ map: MAMap) {
        map.addOverlays(lines)
    }
    
    func map(_ map: MAMap!, rendererFor overlay: MAOverlay!) -> MAOverlayRenderer! {
        
        if (overlay.isKind(of: MAMultiPolyline.self))
        {
            let renderer = MAMultiColoredPolylineRenderer.init(multiPolyline: overlay as! MAMultiPolyline?)
            
            renderer?.lineWidth = 10.0
            
            let index = lines.firstIndex(where: {$0 === overlay})
            
            if(index == 0) {
                renderer?.strokeColors = [UIColor.blue, UIColor.white, UIColor.black, UIColor.green];
            } else {
                renderer!.alpha = 0.6;
                renderer?.strokeColors = [UIColor.red, UIColor.yellow, UIColor.green]
            }
            
            return renderer;
        }
        
        return nil;
    }
}
