//
//  LocationBaseViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/26.
//

import Foundation

class LocationBaseViewController: MAMapBaseViewController,AMapLocationManagerDelegate {
    
    var locationManager:AMapLocationManager! = nil;
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        initLocationManager()
    }
    
    func initLocationManager() {
        locationManager = AMapLocationManager.init()
        locationManager.delegate = self;
        if #available(iOS 14.0, *) {
            locationManager.locationAccuracyMode = AMapLocationAccuracyMode.fullAndReduceAccuracy
        }
    }
    
    func startLocation() {
        locationManager.startUpdatingLocation()
    }
    
    func startLocationHeading() {
        locationManager.startUpdatingHeading()
    }
    
    func didUpdateLocation(_ location:CLLocation, reGeocode:AMapLocationReGeocode?){
        print("子类使用定位数据需要重写此方法，didUpdateLocation:reGeocode:")
    }
    
    func didUpdateHeading(_ newHeading:CLHeading){
        print("子类使用定位数据需要重写此方法，didUpdateHeading:")
    }
    
    //MARK: -----AMapLocationManagerDelegate
    func amapLocationManager(_ manager: AMapLocationManager!, didUpdate location: CLLocation!, reGeocode: AMapLocationReGeocode!) {
        didUpdateLocation(location, reGeocode: reGeocode)
    }
    
    func amapLocationManager(_ manager: AMapLocationManager!, didUpdate newHeading: CLHeading!) {
        didUpdateHeading(newHeading)
    }
    
    func amapLocationManager(_ manager: AMapLocationManager!, doRequireLocationAuth locationManager: CLLocationManager!) {
        locationManager.requestAlwaysAuthorization()
    }
    
    func amapLocationManager(_ manager: AMapLocationManager!, doRequireTemporaryFullAccuracyAuth locationManager: CLLocationManager!, completion: ((Error?) -> Void)!) {
        if #available(iOS 14.0, *) {
            locationManager.requestTemporaryFullAccuracyAuthorization(withPurposeKey: "", completion: completion)
        }
    }
}
