//
//  ViewController.swift
//  Lite3DMapDemo-swift
//
//  Created by JZ on 2021/2/25.
//

import UIKit

class ViewController: UIViewController,MainViewControllerDelegate {
    var maps: Dictionary<String,UIViewController.Type>!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "高德轻量版地图API-3D-Swift"
        
        maps = ["MapTypeViewController"         :   MapTypeViewController.self,
                "PreLoadMapViewController"      :   PreLoadMapViewController.self,
                "AnnotationViewController"      :   AnnotationViewController.self,
                "MovingAnnotationViewController":   MovingAnnotationViewController.self,
                "CustomAnnotationViewController":   CustomAnnotationViewController.self,
                "OperateMapViewController"      :   OperateMapViewController.self,
                "ChangeZoomViewController"      :   ChangeZoomViewController.self,
                "ChangeCenterViewController"    :   ChangeCenterViewController.self,
                "MapBoundaryViewController"     :   MapBoundaryViewController.self,
                "LongGestureViewController"     :   LongGestureViewController.self,
                "ColoredLinesOverlayViewController" : ColoredLinesOverlayViewController.self,
                "CircleOverlayViewController"   :   CircleOverlayViewController.self,
                "LinesOverlayViewController"    :   ColoredLinesOverlayViewController.self,
                "PolygonOverlayViewController"  :   PolygonOverlayViewController.self,
                "CoordinateConvertViewController"   : CoordinateConvertViewController.self,
                "CooridinateSystemConvertController": CooridinateSystemConvertController.self,
                "PointToPointDistanceViewController": PointToPointDistanceViewController.self,
                "InsideTestViewController"      :   InsideTestViewController.self,
                "PointToLineDistanceViewController" : PointToLineDistanceViewController.self,
                "UserLocationViewController"    :   UserLocationViewController.self
        ]
        
        let vc = MainViewController.init();
        vc.delegate = self;
        vc.view.bounds = self.view.bounds;
        vc.view.autoresizingMask = [UIView.AutoresizingMask.flexibleHeight, UIView.AutoresizingMask.flexibleWidth];
        self.view.addSubview(vc.view);
        self.addChild(vc)
    }

    override func viewWillAppear(_ animated: Bool) {
        self.navigationController?.setToolbarHidden(true, animated: false)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func viewController(_ vc: MainViewController!, itemSelected itemClassName: String!, title: String!) -> Bool {
        let vcClass = self.maps[itemClassName]
        if(vcClass != nil) {
            if(vcClass == UIViewController.self) {
                return true
            }

            let vcInstance = vcClass!.init()
            vcInstance.title = title

            self.navigationController?.pushViewController(vcInstance, animated: true)
        }

        return true
    }

    func viewController(_ vc: MainViewController!, displayTileOf itemClassName: String!) -> String! {
        let vcClass = self.maps[itemClassName]
        if(vcClass != nil) {
            if(vcClass == UIViewController.self) {
                return nil
            }

            return NSStringFromClass(vcClass!)
        }

        return nil
    }
}

