//
//  MAWKWebView.m
//  MAMapKit
//
//  Created by JZ on 2020/12/22.
//

#import "MAWKWebView.h"
#import <WebKit/WebKit.h>

@interface MAWKWebView()

@end

@implementation MAWKWebView

- (instancetype)initWithFrame:(CGRect)frame{
    self = [super init];
    if (self) {
        [self initWebViewWith:frame];
    }
    return self;
}

- (void)initWebViewWith:(CGRect)frame{
    WKWebViewConfiguration *configuration = [[WKWebViewConfiguration alloc]init];
    WKUserContentController *content = [[WKUserContentController alloc]init];
    configuration.userContentController = content;
    if (@available(iOS 11.0, *)) {
        //iOS11之后，注册轻量版地图SDK网络拦截监听
        NSArray<MACustomSchemeModel*> *array = [MAMap customSchemeArray];
        for (MACustomSchemeModel *model in array) {
            [configuration setURLSchemeHandler:model.urlSchemeHandler forURLScheme:model.urlScheme];
        }
    }else{

    }
    _webView = [[WKWebView alloc] initWithFrame:frame configuration:configuration];
}

- (WKWebViewConfiguration*)configuration{
    return self.webView.configuration;
}

- (nullable WKNavigation *)loadHTMLString:(NSString *)string baseURL:(nullable NSURL *)baseURL{
    return [self.webView loadHTMLString:string baseURL:baseURL];
}

- (nullable WKNavigation *)loadRequest:(NSURLRequest *)request{
    return [self.webView loadRequest:request];
}

- (void)evaluateJavaScript:(NSString *)javaScriptString completionHandler:(void (^ _Nullable)(_Nullable id, NSError * _Nullable error))completionHandler{
    return [self.webView evaluateJavaScript:javaScriptString completionHandler:completionHandler];
}

- (void)setFrame:(CGRect)frame{
    self.webView.frame = frame;
}

- (void)addSubView:(UIView*)view{
    [self.webView addSubview:view];
}

- (void)dealloc{
    NSLog(@"MAWKWebView --- dealloc");
}

@end
