//
//  MapTypeViewController.m
//  Category_demo
//
//  Created by songjian on 13-3-21.
//  Copyright (c) 2013年 songjian. All rights reserved.
//

#import "MapTypeViewController.h"

@interface MapTypeViewController ()<MAMapDelegate>

@end

@implementation MapTypeViewController

#pragma mark - Life Cycle
- (void)viewDidLoad
{
    [super viewDidLoad];
    [self initRightNaviItem];
    //初始化工具toolBar
    [self initToolBar];
    //加载地图
    [self.map createMap];
    //在视图上添加webView
    [self addWebView];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.navigationController.toolbar.barStyle      = UIBarStyleDefault;
    self.navigationController.toolbar.translucent   = YES;
    [self.navigationController setToolbarHidden:NO animated:animated];
}

#pragma mark - Action Handlers

- (void)initRightNaviItem{
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"reload"
                                                                             style:UIBarButtonItemStylePlain
                                                                            target:self
                                                                            action:@selector(reload)];
}

- (void)reload{
    [self.map createMap];
}

- (void)mapTypeAction:(UISegmentedControl *)segmentedControl
{

    self.map.mapType = segmentedControl.selectedSegmentIndex+1;
}

#pragma mark - Initialization

- (void)initToolBar
{
    UIBarButtonItem *flexbleItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:self action:nil];
    
    UISegmentedControl *mapTypeSegmentedControl = [[UISegmentedControl alloc] initWithItems:
                                                   [NSArray arrayWithObjects:
                                                    @"标准",
                                                    @"卫星",
                                                    @"黑夜",
                                                    nil]];
    mapTypeSegmentedControl.selectedSegmentIndex  = self.map.mapType-1;
    [mapTypeSegmentedControl addTarget:self action:@selector(mapTypeAction:) forControlEvents:UIControlEventValueChanged];
    
    UIBarButtonItem *mayTypeItem = [[UIBarButtonItem alloc] initWithCustomView:mapTypeSegmentedControl];
    
    self.toolbarItems = [NSArray arrayWithObjects:flexbleItem, mayTypeItem, flexbleItem, nil];
}

@end
