//
//  ChangeCenterViewController.m
//  MAMapKit_3D_Demo
//
//  Created by shaobin on 16/8/16.
//  Copyright © 2016年 Autonavi. All rights reserved.
//

#import "ChangeCenterViewController.h"


@interface ChangeCenterViewController ()<MAMapDelegate>

@end

@implementation ChangeCenterViewController

#pragma mark - Life Cycle
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Back"
                                                                             style:UIBarButtonItemStylePlain
                                                                            target:self
                                                                            action:@selector(returnAction)];
    
    //加载地图
    [self.map createMap];
    //在视图上添加webView
    [self addWebView];
    
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 40)];
    label.textAlignment = NSTextAlignmentCenter;
    label.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.5];
    label.textColor = [UIColor whiteColor];
    label.text = @"点击地图任意位置设为新中心点";
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleBottomMargin;
    [self.view addSubview:label];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    
    self.map.zoomLevel = 11;
    self.map.centerCoordinate = CLLocationCoordinate2DMake(39.907728, 116.397968);
    
    CLLocationCoordinate2D newLoc = CLLocationCoordinate2DMake(39.957995, 116.454246);
    [self changeCenterTo:newLoc];
}

- (void)changeCenterTo:(CLLocationCoordinate2D)newLoc
{
    [self.map setCenterCoordinate:newLoc animated:YES];
}

#pragma mark - Action Handlers
- (void)returnAction
{
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark - map Delegate
- (void)map:(MAMap *)map didSingleTappedAtCoordinate:(CLLocationCoordinate2D)coordinate {
    [self changeCenterTo:coordinate];
}

@end
