//
//  LongGestureViewController.m
//  Lite3DMapDemo
//
//  Created by JZ on 2021/1/7.
//

#import "LongGestureViewController.h"

@interface LongGestureViewController ()<UIGestureRecognizerDelegate>

///长按手势
@property (nonatomic, strong) UILongPressGestureRecognizer *longPressGestureRecognizer;

@end

@implementation LongGestureViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    //加载地图
    [self.map createMap];
    //在视图上添加webView
    [self addWebView];
    
    [self initLongGesture];
}

- (void)initLongGesture{
    ///long press
    _longPressGestureRecognizer = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(longPressGesture:)];
    _longPressGestureRecognizer.delegate = self;
    [self.view addGestureRecognizer:_longPressGestureRecognizer];
}

#pragma mark ---------------- mapDelegate ---------------
- (void)map:(MAMap *)map didLongPressedAtCoordinate:(CLLocationCoordinate2D)coordinate{
    NSLog(@"LongGesture coordinate: lat = %.6lf,lon = %.6lf",coordinate.latitude,coordinate.longitude);
    
    MAPointAnnotation *p = [[MAPointAnnotation alloc]init];
    p.coordinate = coordinate;
    [self.map addAnnotation:p];
}

#pragma mark ---------------- longPressGesture ---------------

- (void)longPressGesture:(UILongPressGestureRecognizer *)gestureRecognizer
{
    [self.map longPressGesture:gestureRecognizer];
}

- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer
{
    if (gestureRecognizer == _longPressGestureRecognizer) {
        return YES;
    }
    return NO;
}

@end
