//
//  CoordinateConvertViewController.m
//  MAMapKit_3D_Demo
//
//  Created by shaobin on 16/8/12.
//  Copyright © 2016年 Autonavi. All rights reserved.
//

#import "CoordinateConvertViewController.h"
#import "UIView+Toast.h"

@interface CoordinateConvertViewController ()<MAMapDelegate>

@end

@implementation CoordinateConvertViewController
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Back"
                                                                             style:UIBarButtonItemStylePlain
                                                                            target:self
                                                                            action:@selector(returnAction)];
    
    //加载地图
    [self.map createMap];
    //在视图上添加webView
    [self addWebView];
    
    UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 40)];
    label.textAlignment = NSTextAlignmentCenter;
    label.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.5];
    label.textColor = [UIColor whiteColor];
    label.text = @"点击地图显示屏幕坐标";
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleBottomMargin;
    [self.view addSubview:label];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:YES];
}

#pragma mark - Action Handlers
- (void)returnAction
{
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark - map delegate
- (void)map:(MAMap *)map didSingleTappedAtCoordinate:(CLLocationCoordinate2D)coordinate {
    [map convertCoordinate:coordinate completeCallback:^(CGPoint point) {
        [self.view makeToast:[NSString stringWithFormat:@"screenPoint =  {%f, %f}", point.x, point.y] duration:1.5];
        
    }];
}

@end
