//
//  DistanceCalculateViewController2.m
//  MAMapKit_3D_Demo
//
//  Created by shaobin on 16/8/12.
//  Copyright © 2016年 Autonavi. All rights reserved.
//

#import "PointToLineDistanceViewController.h"
#import "UIView+Toast.h"
#import "CommonUtility.h"

@interface PointToLineDistanceViewController ()<MAMapDelegate>

@property (nonatomic, strong) MAPolyline *line;

@end

@implementation PointToLineDistanceViewController
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Back"
                                                                             style:UIBarButtonItemStylePlain
                                                                            target:self
                                                                            action:@selector(returnAction)];
    
    //加载地图
    [self.map createMap];
    //在视图上添加webView
    [self addWebView];
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:YES];
    
    //line 1
    CLLocationCoordinate2D line1Points[2];
    line1Points[0].latitude = 39.925539;
    line1Points[0].longitude = 116.0;
    
    line1Points[1].latitude = 39.925539;
    line1Points[1].longitude = 116.5;
    
    MAPolyline *line1 = [MAPolyline polylineWithCoordinates:line1Points count:2];
    [self.map addOverlay:line1];
    self.line = line1;
    
    MAPointAnnotation *a1 = [[MAPointAnnotation alloc] init];
    a1.title = @"拖动我哦";
    a1.coordinate =  CLLocationCoordinate2DMake(39.992520, 116.336170);
    [self.map addAnnotation:a1];
    
    [self.map selectAnnotation:a1 animated:YES];
}

#pragma mark - Action Handlers
- (void)returnAction
{
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark - MAMapDelegate
- (MAAnnotationView*)map:(MAMap *)map viewForAnnotation:(id <MAAnnotation>)annotation {
    if ([annotation isKindOfClass:[MAPointAnnotation class]])
    {
        MAPinAnnotationView *annotationView = [[MAPinAnnotationView alloc] initWithAnnotation:annotation];
        
        annotationView.canShowCallout               = YES;
        annotationView.draggable                    = YES;
        annotationView.rightCalloutAccessoryView    = nil;
        
        return annotationView;
    }
    
    return nil;
}

- (MAOverlayRenderer *)map:(MAMap *)map rendererForOverlay:(id <MAOverlay>)overlay
{
    if ([overlay isKindOfClass:[MAPolyline class]])
    {
        MAPolylineRenderer *polylineRenderer = [[MAPolylineRenderer alloc] initWithPolyline:overlay];
        polylineRenderer.strokeColor = [UIColor blueColor];
        polylineRenderer.lineWidth   = 2.f;
        polylineRenderer.lineDashType = kMALineDashTypeNone;
        
        return polylineRenderer;
    }
    
    return nil;
}

- (void)map:(MAMap *)map annotationView:(MAAnnotationView *)view didChangeDragState:(MAAnnotationViewDragState)newState fromOldState:(MAAnnotationViewDragState)oldState {
    if(newState == MAAnnotationViewDragStateEnding) {
        CLLocationCoordinate2D loc = view.annotation.coordinate;
        MAMapPoint p = MAMapPointForCoordinate(loc);
        double distance = [CommonUtility distanceToPoint:p fromLineSegmentBetween:self.line.points[0] and:self.line.points[1]];

        [self.view makeToast:[NSString stringWithFormat:@"%f", distance] duration:1.0];
    }
}

@end
